// modified by ikkei for ikkeiplexing shield 2010.12.19
/*** Scroll Animation
 * by arms22 <http://arms22.blog91.fc2.com/>
 * 
 * Demonstrates the use of the Dots library
 * 
 * Matrix  Arduino
 * 1  R5 -> 17(analog 3)
 * 2  R7 -> 16(analog 2)
 * 3  C2 -> 15(analog 1)
 * 4  C3 -> 14(analog 0)
 * 5  R8 -> 13
 * 6  C5 -> 12
 * 7  R6 -> 11
 * 8  R3 -> 10
 * 9  R1 -> 9
 * 10 C4 -> 8
 * 11 C6 -> 7
 * 12 R4 -> 6
 * 13 C1 -> 5
 * 14 R2 -> 4
 * 15 C7 -> 3
 * 16 C8 -> 2
 */

#include <MsTimer2.h>
#include <Charlieplexing.h>
//#include <Dots.h>

//Dots myDots = Dots(9,4,10,6,17,11,16,13,5,15,14,8,12,7,3,2);

const byte scroll_image[] = {
  B00000000,
  B01111110,
  B00000000,
  B00000000,
  B00000000,
  B01111100,
  B00010010,
  B00010010,
  B01111100,
  B00000000,
  B01111110,
  B00000100,
  B00000100,
  B01111110,
  B00000000,
  B01110000,
  B01001000,
  B01101000,
  B00111000,
  B00000000,
  B01111110, 
  B01000010, 
  B01000010, 
  B00111100, 
  B00000000, 
  B00111100, 
  B01000010, 
  B01000010, 
  B00111100, 
  B00000000, 
  B00000010, 
  B01111110,
  B00000010, 
  B00000000, 
  B00001000, 
  B01010100, 
  B01010100, 
  B00100000,
};

int img_h = sizeof(scroll_image) / sizeof(scroll_image[0]);
int wnd_y;

void setup()
{
  wnd_y = -16;
  //myDots.begin();
  iLedSign::Init();
}

void loop()
{
  //myDots.clear();
  iLedSign::Clear(0);

  if(wnd_y < 0){
    //myDots.write(-wnd_y, &scroll_image[0], 8 + wnd_y);
    iLedSign::write90(-wnd_y, &scroll_image[0], 16 + wnd_y);
  }
  else if(wnd_y < (img_h - 16)){
    //myDots.write(0, &scroll_image[wnd_y], 8);
    iLedSign::write90(0, &scroll_image[wnd_y], 16);
  }
  else{
    //myDots.write(0, &scroll_image[wnd_y], img_h - wnd_y);
    iLedSign::write90(0, &scroll_image[wnd_y], img_h - wnd_y);
  }

  wnd_y++;
  if(wnd_y >= img_h){
    wnd_y = -16;
  }
  
  //myDots.updateWithDelay(100);
  delay(100);
}










